/**
 * SO, 2010 - Lab #6, Semnale
 * Task #0, Linux
 * 
 * Catching signals
 */


#include <stdio.h>
#include <signal.h>
#include <unistd.h>

int must_leave = 0;

static void sig_handler(int signum)
{
	switch(signum) {
	case SIGTSTP:
		printf("H");
		break;
	case SIGTTIN:
		printf("e");
		break;
	case SIGTTOU:
		printf("l");
		break;
	case SIGURG:
		printf("l");
		break;
	case SIGXCPU:
		printf("o");
		break;
	case SIGXFSZ:
		printf("\n");
		must_leave = 1;
		break;
	default:
		printf("Go back and send the following signals: 20, 21, 22, 23, 24");
		must_leave = 1;
	}	
	fflush(stdout);
}

int main(void)
{
	struct sigaction signals;
	sigset_t mask;

	sigfillset(&mask);

	signals.sa_flags = SA_RESETHAND;
	signals.sa_mask = mask;

	signals.sa_handler = sig_handler;
	
	sigaction(SIGTSTP, &signals, NULL);
	sigaction(SIGTTIN, &signals, NULL);
	sigaction(SIGTTOU, &signals, NULL);
	sigaction(SIGURG,  &signals, NULL);
	sigaction(SIGXCPU, &signals, NULL);
	sigaction(SIGXFSZ, &signals, NULL);
	
	while(!must_leave) sleep(1);

	return 0;
}
